package com.brave;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.brave.utils.BaiDuAiConfig;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;
import java.util.Map;

/**
 * 获取API访问权限token
 */
public class AccessToken {

    public static void main(String[] args) throws IOException {
        System.out.println(getAuth(BaiDuAiConfig.API_KEY,BaiDuAiConfig.SECRET_KEY));
    }

    private static String getAuth(String ak, String sk) throws IOException {
        String authHost ="https://aip.baidubce.com/oauth/2.0/token?";
        String getAccessTokenUrl=authHost
                +"grant_type=client_credentials"
                +"&client_id="+ak
                +"&client_secret="+sk;

        try {
            URL realurl = new URL(getAccessTokenUrl);
            HttpURLConnection connection = (HttpURLConnection) realurl.openConnection();
            connection.setRequestMethod("GET");
            connection.connect();
            //获取所有响应头字段
            Map<String, List<String>> map = connection.getHeaderFields();
            //遍历所有的响应头字段
            for (String key : map.keySet()) {
                System.err.println(key+"---->"+map.get(key));
            }
            //定义BufferReader输入流来读取URL的响应
            BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
            String result="";
            String line;
            while ((line=in.readLine()) != null){
                result+=line;
            }

            System.out.println("====Token_Result====="+result);
            JSONObject jsonObject = JSON.parseObject(result);
            String access_token = jsonObject.getString("access_token");
            return access_token;
        } catch (MalformedURLException e) {
            System.err.println("获取token失败！");
            e.printStackTrace(System.err);
        }

        return null;
    }
}
