package com.brave.entity;

import java.util.List;

/**
 * 图片审核结果返回
 */
public class ImageCheckReturn {
    /**
     * 请求唯一ID，用于问题定位
     */
    private long log_id;
    /**
     * 审核结果，可取值：合规、不合规、疑似、审核失败
     */
    private String conclusion;
    /**
     * 审核结果类型，可取值1.合规、2.不合格、3.疑似、4.审核失败
     */
    private Integer conclusionType;

    /**
     * 不合规/疑似/命中白名单项详细信息
     */
    private List<ImageData> data;


    @Override
    public String toString() {
        return "ImageCheckReturn{" +
                "log_id=" + log_id +
                ", conclusion='" + conclusion + '\'' +
                ", conclusionType=" + conclusionType +
                ", data=" + data +
                '}';
    }

    public long getLog_id() {
        return log_id;
    }

    public void setLog_id(long log_id) {
        this.log_id = log_id;
    }

    public String getConclusion() {
        return conclusion;
    }

    public void setConclusion(String conclusion) {
        this.conclusion = conclusion;
    }

    public Integer getConclusionType() {
        return conclusionType;
    }

    public void setConclusionType(Integer conclusionType) {
        this.conclusionType = conclusionType;
    }

    public List<ImageData> getData() {
        return data;
    }

    public void setData(List<ImageData> data) {
        this.data = data;
    }
}
