package com.brave.service.imp;

import com.brave.domain.Moreover;
import com.brave.mapper.MoreoverMapper;
import com.brave.result.Result;
import com.brave.service.MoreoverService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class MoreoverServiceImpl implements MoreoverService {

    @Autowired
    private MoreoverMapper moreoverMapper;


    @Override
    public Moreover findById(Integer id) {
        Moreover moreover=moreoverMapper.findById(id);
        if (moreover!=null){
            Integer parentId = moreover.getId();
            List<Moreover> moreoverList=moreoverMapper.findByParentId(parentId);
            moreover.setChildren(moreoverList);
            getTree(moreoverList);
        }
        return moreover;
    }

    @Override
    public Result del(Integer id) {
        moreoverMapper.deleteById(id);
        return Result.success();
    }

    @Override
    public Result add(Moreover moreover) {
        moreoverMapper.add(moreover);
        return Result.success();
    }

    private void getTree(List<Moreover> moreoverList) {
        List<Moreover> retList = new ArrayList<>();
        for (Moreover moreover : moreoverList) {
            retList=moreoverMapper.findByParentId(moreover.getId());

            if (retList.size()>0){
                moreover.setChildren(retList);
                getTree(retList);
            }
        }
    }
}
