package com.brave.controller;

import com.brave.domain.Disease;
import com.brave.result.Result;
import com.brave.service.DiseaseService;
import com.brave.utils.BaiDuAiCheck;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;

@RestController
@RequestMapping("/disease")
public class DiseaseController {

    @Autowired
    private DiseaseService diseaseService;



    @GetMapping("/findById/{id}")
    public Disease findById(@PathVariable Integer id){
        Disease disease=diseaseService.findById(id);
        return disease;


    }



    @PostMapping("/addDisease")
    public Object addDisease(@RequestBody Disease disease){
        JSONObject jsonObject = new JSONObject();
        JSONObject result = BaiDuAiCheck.checkText(disease.getName());
        System.out.println(result);
        if (result.get("conclusion")==null){
            jsonObject.put("code",2);
        } else if (result.get("conclusion").equals("合规")) {
            jsonObject.put("code",1);
            Result result1=diseaseService.addDisease(disease);
            return result1;
        }else {
            jsonObject.put("code",3);
        }

        return jsonObject;
    }


    @PostMapping({"/upLoadImg/{type}"})
    public JSONObject upLoadImg(@RequestParam("file")MultipartFile file,@PathVariable("type")String type) throws IOException {
        JSONObject jsonObject = new JSONObject();
        JSONObject result = BaiDuAiCheck.checkImg(file);
        if (result.get("conclusion")==null){
            jsonObject.put("code",1);
        } else if (result.get("conclusion").equals("合规")) {
            JSONObject srcJson = new JSONObject();
            srcJson.put("src","http://");
            jsonObject.put("code",0);
            jsonObject.put("msg","上传成功");
            jsonObject.put("data",srcJson);
        }else {
            jsonObject.put("code",3);
            jsonObject.put("msg","疑似或存在违规图片！请勿传播非法内容");
        }

        return jsonObject;
    }



}
