package com.brave.service.imp;

import com.brave.domain.Disease;

import com.brave.mapper.DiseaseMapper;
import com.brave.result.Result;
import com.brave.service.DiseaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class DiseaseServiceImpl implements DiseaseService {
    @Autowired
    private DiseaseMapper diseaseMapper;

    @Override
    public Disease findById(Integer id) {
        Disease disease=diseaseMapper.findById(id);
        if (disease!=null){
            Integer parentId = disease.getId();
            List<Disease> diseaseList=diseaseMapper.findByParentId(parentId);
            disease.setChildren(diseaseList);
            getTree(diseaseList);
        }
        return disease;
    }

    @Override
    public Result addDisease(Disease disease) {
        diseaseMapper.addDisease(disease);

        return Result.success();
    }


    private void getTree(List<Disease> diseaseList) {
        List<Disease> retList = new ArrayList<>();
        for (Disease disease : diseaseList) {
            retList=diseaseMapper.findByParentId(disease.getId());

            if (retList.size()>0){
                disease.setChildren(retList);
                getTree(retList);
            }
        }
    }
}
